import React from 'react';

class RECT extends React.Component{
   
   constructor(props){
      super(props)
      this.renderD3Component = this.renderD3Component.bind(this)
      console.log('RECT',props)
   }
  
   renderD3Component(){ 
      const render = HorizontalRectComponent(this.node,{
        height:this.props.height,
        width:this.props.width,
        value:this.props.value,
        pos:this.props.pos,
        offset:this.props['padding-left']
      })
      render(this.props.data)
   }
  
   componentDidMount(){
      this.renderD3Component()
   }
  
   componentDidUpdate(){
      this.renderD3Component()
   } 
  
   render(){
     return <g ref = {node => this.node = node}></g>
   }
}

export default RECT;

import { 
         select,
         scaleBand,
         scaleLinear,
         max,
         range
       } 
from 'd3'; 

const HorizontalRectComponent = (selection, props) => {

       const render = data => {
            selection = select(selection)
            let y = props.value
            let x = props.pos
            
            const draw = () => {
                 
                 const yscale = scaleLinear().domain([0,max(y(data))]).range([0,props.width])
                 
                 const xscale = scaleBand().domain(x(data))
                                           .range([0,props.height])
                                           .padding(props.padding? props.padding: 0.2);
                 
                 console.log(selection)
                 
                 
                 console.log(y(data))
                 
              
                 const rects = selection.attr('transform',`translate(${props.offset},0)`)
                                      .selectAll('rect')
                                      .data(x(data))
                                      .enter()
                                      .append('rect')
                 rects.attr('id', d=> d)
                      .attr('height',d => xscale.bandwidth() )
                      .attr('width',d => yscale(data[d]) )
                      .attr('y',d => xscale(d))
                      .style('fill','steelblue')
                      .on('click',d => {
                          rects.filter( d1 => d1 == d ).style('fill','red')
                          rects.filter( d1 => d1 != d ).style('fill','steelblue')
                      })
                                          
                               
                                    
            }
            
            draw()
          
        }
       return render;
}