import React from 'react';
import ReactDOM from 'react-dom';
import Canvas from './canvas'
import AXIS from './axis'
import CHART from './chart'
import RECT from './rect'
import NAV from './nav';


const App = () => <div className="message">Hello React!</div>;

const getData = async () => {
     
     var promise = new Promise(function(resolve, reject) { 
    				resolve({'hello':12,'world':13,'keeper':25}); 
    	}) ;
     return promise;
  }

ReactDOM.render(<Canvas width = '500' height = '500' 
                  children = {[
                      
      
                       <NAV children = {[
                               <CHART padding-left = '80' listener
                             children = {[
                                 <AXIS xscale = 'linear' 
                                        transform = { Object.values}
                                   />,
                                 <AXIS yscale = 'ordinal' 
                                        transform = { Object.keys}
                                        padding  = { 0.2}
                                   />,
                                 <RECT  value = { Object.values }  
                                        pos = { Object.keys } 
                                        padding  = { 0.2}    
                                        click = { () => {} }
                                   />
                              ]}
                             
                             height = '250' 
                             width = '250'/>,
                            ]} />
                        
                      
          				]}
                  data = { getData() }  
                />, document.getElementById('root'));
